/**
 * Copyright 2020 Cohesity Inc.
 *
 * Author : Qing Wan
 *
 * generate sql script to create new controlfile with new redo log path
*/

define redo_log_path = '&1'
define path_separator = &2

WHENEVER OSERROR EXIT 11;
WHENEVER SQLERROR EXIT 22;
connect / as sysdba
SET VERIFY OFF;
SET ECHO OFF;
SET SERVEROUTPUT ON;
SET HEADING OFF;
SET FEEDBACK OFF;
SET LINE 32000;
select 'CREATE CONTROLFILE REUSE SET DATABASE ' || '"' ||
  db_unique_name || '"' || ' RESETLOGS  ARCHIVELOG '
  from v$database;
Select 'MAXDATAFILES ' || records_total
  from v$controlfile_record_section
  where type = 'DATAFILE';
Select 'MAXLOGHISTORY ' || records_total
  from v$controlfile_record_section
  where type = 'LOG HISTORY';
Select 'MAXINSTANCES ' || records_total
  from v$controlfile_record_section
  where type = 'DATABASE';
Select 'MAXLOGFILES ' || records_total
  from v$controlfile_record_section
  where type = 'REDO LOG';
Select 'MAXLOGMEMBERS ' || dimlm from x$kccdi;
select 'LOGFILE' from dual;
select 'GROUP ' || a.GROUP# || '  ' ||  '(''' || LISTAGG('&redo_log_path' ||
  substr(a.member,instr(a.member,'&path_separator',-1,1)+1),''',''')
  WITHIN GROUP(order by a.GROUP#) || ''')'||
  ' size ' || b.bytes/1024/1024 || 'M, '
  from v$logfile a , v$log b
  where a.group# < (select max(group#) from v$log ) and a.group#=b.group#
  group by a.group#  ,b.bytes;
select 'GROUP ' || a.GROUP# || '  ' ||  '(''' | | LISTAGG('&redo_log_path' ||
  substr(member,instr(member,'&path_separator',-1,1)+1),''',''') WITHIN GROUP(order by a.GROUP#)
  || ''')'|| ' size ' || b.bytes/1024/1024 || 'M '
  from v$logfile a, v$log b
  where a.group# = (select max(group#) from v$log ) and a.group#=b.group#
  group by a.group#  ,b.bytes;
select 'DATAFILE' from dual;
select '''' || name  || '''' || ','
  from v$datafile
  where file# <(select max(file#) from v$datafile);
select '''' || name  || ''''
  from v$datafile
  where file# =  ( select max(file#) from v$datafile);
select 'CHARACTER SET ' || value
  from v$nls_parameters
  where PARAMETER = 'NLS_CHARACTERSET';
select ';' from dual;
exit;