/**
 * Copyright 2020 Cohesity Inc.
 *
 * Author : Manipal Singh
 *
 * Fetches the datafile information for the database based on mountpath pattern.
 * Only those datafiles and their corresponding container name will be fetched
 * whose name is like the given mountpath.
 */

define common_path = '&5'
define column_separator = &4
define mountpoint_pattern = &6
@"&common_path/common.sql"

/* Setting auto print to on as this will print the select outputs to stdout. */
SET AUTOPRINT ON;

/* refcursor to print the values to stdout */

var v_rc refcursor;
set echo on;
DECLARE
  sql_stmt   VARCHAR2(32767);
BEGIN
  sql_stmt := '
  SELECT /*+ RULE */
  -- Column#: 1
  c.CON_ID
  ||''&column_separator''||
  -- Column#: 2
  c.NAME
  ||''&column_separator''||
  -- Column#: 3
  d.NAME
  FROM V$DATAFILE d
  JOIN V$CONTAINERS c ON c.CON_ID=d.CON_ID
  where d.NAME like ''&mountpoint_pattern''
  ';
  open :v_rc for sql_stmt;
END;
/
quit;
