/**
 * Copyright 2020 Cohesity Inc.
 *
 * Author : Manipal Singh
 *
 * Fetches the redo log information for the database based on mountpath pattern.
 */

define common_path = '&5'
define column_separator = &4
define mountpoint_pattern = &6
@"&common_path/common.sql"

/* Setting auto print to on as this will print the select outputs to stdout. */
SET AUTOPRINT ON;

/* refcursor to print the values to stdout */

var v_rc refcursor;
set echo on;
DECLARE
  sql_stmt   VARCHAR2(32767);
BEGIN
  sql_stmt := '
  SELECT /*+ RULE */
  -- Column#: 1
  a.GROUP#
  ||''&column_separator''||
  -- Column#: 2
  a.STATUS
  ||''&column_separator''||
  -- Column#: 3
  CEIL(max(a.BYTES/1024/1024))
  ||''&column_separator''||
  -- Column#: 4
  count(b.MEMBER)
  FROM V$LOG a
  JOIN V$LOGFILE b ON a.GROUP#=b.GROUP#
  where b.MEMBER like ''&mountpoint_pattern''
  group by a.GROUP#, a.STATUS
  ';
  open :v_rc for sql_stmt;
END;
/
quit;
