/**
 * Copyright 2019 Cohesity Inc.
 *
 * Author : Mahesh K
 *
 * Unplug a given PDB into xml file.
 */
define common_path='&5'
define column_separator = &4
@"&common_path/common.sql"

define pdb_name = &6;
define xml_location = &7;
set autoprint on;

var v_rc refcursor;
/* Declare variables */
DECLARE
    PDB_STATUS VARCHAR2(10);
BEGIN
    /* Check for pdb status, if the pdb is open, then close it */
    SELECT /*+ RULE*/ OPEN_MODE INTO PDB_STATUS FROM V$PDBS
            WHERE UPPER(NAME) = UPPER('&pdb_name');
    if PDB_STATUS <> 'MOUNTED' THEN
            dbms_output.put_line('mounted');
            Execute immediate 'alter pluggable database &pdb_name close';
    END IF;
    EXECUTE IMMEDIATE 'ALTER SESSION SET CONTAINER = &pdb_name';
    /* Print all the datafiles for a given pdb */
    OPEN :v_rc FOR
            SELECT /*+ RULE*/ name||'&column_separator'||bytes FROM v$datafile;
END;
/
/* Unplug PDB to a xml file */

ALTER SESSION SET CONTAINER=cdb$root;
/* Unplug PDB to a xml file */
alter pluggable database &pdb_name unplug into '&xml_location';
quit;
